/*
 * Copyright (c) 2001,2002 Eric Moore
 * Copyright (c) 2001,2002 Vanishree Sabapathi
 * Copyright (c) 2002 LSI Logic Corporation
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The party using or redistributing the source code and binary forms
 *    agrees to the disclaimer below and the terms and conditions set forth
 *    herein.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 *	$FreeBSD: src/sys/contrib/dev/mide/inc/mide_adapter.h,v emoore Exp$
 */

#ifndef __MEGAIDE_ADAPTER_H__
#define __MEGAIDE_ADAPTER_H__

#ifndef	BP_SUPPORT
#define	BP_SUPPORT 1
#endif
/*
*-------------------------------------------------------------------
* Macros Definition
*-------------------------------------------------------------------
*/
#define	DELL_SUPPORT			1
#define	HYPERDISK_MAJOR_VERSION		02
#define	HYPERDISK_MINOR_VERSION		01
#define	HYPERDISK_BUILD_VERSION		00
#define	MEGAIDE_VERSION	"driver version 02.01 (Date: Jan 03, 2003; 16:47 EST)\n"
#define	M_IDE_CRLFSTR			"\n"


#define	M_IDE_HOST_INITIATOR_ID		0xFF
#define	M_IDE_MAX_SGLIST		32	/* 128K transfer*/
#define	M_IDE_MAX_CMD_PER_LUN		20

#define	M_IDE_MAX_CHANNELS		1
#define	M_IDE_MAX_TARGET_PER_CHAN	4
#define	M_IDE_MAX_LOGICAL_DRIVES	8

#define	M_IDE_MAX_COMMANDS 		M_IDE_MAX_CMD_PER_LUN


#define	M_IDE_IN_ISR			0x80000000L
#define	M_IDE_IN_ABORT			0x40000000L
#define	M_IDE_IN_RESET			0x20000000L
#define	M_IDE_IN_QUEUE			0x10000000L
#define	M_IDE_BLOCK_CMD			0x08000000L
#define	M_IDE_REQUEST_IRCD_UPDATE	0x04000000L
#define	M_IDE_REQUEST_ERRORREC		0x02000000L
#define	M_IDE_REQUEST_LOGERROR		0x01000000L


#define	M_IDE_FOR_CHANNEL2		0x00000002L
#define	M_IDE_FOR_CHANNEL1		0x00000001L

#define	POWER_MANAGEMENT_SUPPORTED 0x08
#define	IDE_COMMAND_STANDBY_IMMEDIATE 0xE0

#define	MAX_RAID1_DRIVES		2
#define	MAX_THRESHOLD_COMMANDS		5
#define	MAX_IOCTL_MEM_ALLOC		5

/*IDE RAID Signature Related definitions*/

#define	IDE_RAID_SIGNATURE		"$XIDE$"
#define	IDE_RAID_SIGNATURE_LENGTH	7
/*manoj 0212 for new IRCD*/
#define	NEW_IDE_RAID_SIGNATURE		"$_IDE$"


#ifndef	PCI_VENDOR_ID_NCR
#define	PCI_VENDOR_ID_NCR		0x1000
#endif

#ifndef	PCI_VENDOR_ID_DELL
#define	PCI_VENDOR_ID_DELL		0x1028
#endif

#ifndef	PCI_VENDOR_ID_AMI
#define	PCI_VENDOR_ID_AMI		0x101e
#endif

#ifndef	PCI_VENDOR_ID_CMD
#define	PCI_VENDOR_ID_CMD		0x1095
#endif

#ifndef	PCI_VENDOR_ID_SERVERWORKS
#define	PCI_VENDOR_ID_SERVERWORKS	0x1166
#endif


#ifndef	PCI_DEVICE_ID_CMD_648
#define	PCI_DEVICE_ID_CMD_648		0x0648
#endif

#ifndef	PCI_DEVICE_ID_CMD_649
#define	PCI_DEVICE_ID_CMD_649		0x0649
#endif

#ifndef	PCI_DEVICE_ID_CMD_680
#define	PCI_DEVICE_ID_CMD_680		0x0680
#endif

#define	PCI_DEVICE_ID_YELLOWSTONE	0x1680

#ifndef	PCI_DEVICE_ID_CMD_3112
#define	PCI_DEVICE_ID_CMD_3112		0x3112
#endif

#ifndef	PCI_SUB_DEVICE_ID_CMD_3112
#define	PCI_SUB_DEVICE_ID_CMD_3112		0x534
#endif

#ifndef	PCI_SUB_VENDOR_ID_CMD_3112
#define	PCI_SUB_VENDOR_ID_CMD_3112		0x1000
#endif


#ifndef	PCI_DEVICE_ID_SERVERWORKS_CSB5IDE
#define	PCI_DEVICE_ID_SERVERWORKS_CSB5IDE	0x0212
#endif

#ifndef	PCI_DEVICE_ID_DELL_CERC_ATA_AS
#define	PCI_DEVICE_ID_DELL_CERC_ATA_AS	0x013B
#endif

/*++manoj 0430 CSB6 Support*/
#ifndef	PCI_DEVICE_ID_SERVERWORKS_CSB6IDE
#define	PCI_DEVICE_ID_SERVERWORKS_CSB6IDE	0x0213
#endif
/*--manoj 0430 CSB6 Support*/

#ifndef	PCI_DEVICE_ID_LSI_524
#define	PCI_DEVICE_ID_LSI_524		0x0524
#endif

#ifndef	PCI_VENDOR_ID_LSI_LOGIC
#define	PCI_VENDOR_ID_LSI_LOGIC		0x1000
#endif

#define	AR_TRUE				1
#define	AR_FALSE			0

#define	AR_SUCCESSS			1
#define	AR_ERROR			0


#define	NO_DRIVE			0
#define	IDE_DRIVE			1

/*Maximum supported Drives and channels and controllers*/

#define	MAX_CONTROLLERS			2
#define	MAX_CHANNELS_PER_CONTROLLER	2
#define	MAX_DRIVES_PER_CHANNEL		2

/*We support Logical, Physical*/
#define	MAX_DRIVE_TYPES			2
/*We support NO_DRIVE and ATA*/
#define	MAX_DEVICE_TYPES		2

#define	MAX_DRIVES_PER_CONTROLLER	(MAX_CHANNELS_PER_CONTROLLER * MAX_DRIVES_PER_CHANNEL)

/*Bytes in an IDE disk sector.*/

#define	IDE_SECTOR_SIZE			512


/*Temporary only: initial stripe size value.*/

#define	STRIPE_SIZE_IN_SECTORS		STRIPE_64KB_IN_SECTORS


/* MIN macro.*/

#define	min(a,b) ((a) <= (b) ? (a) : (b))


/*0-based RAID configuration sector number.*/

#define	RAID_CONFIGURATION_SECTOR	6


/* Memory page size.*/
#ifndef	PAGE_SIZE
#define	PAGE_SIZE			0x1000
#endif

#define	MAX_STRIPES_PER_ROW		MAX_DRIVES_PER_CONTROLLER

/* Minimum stripe size supported.*/
#define	MIN_STRIPE_SIZE_IN_SECTORS	32


/* Memory page size in sectors.*/

#define	PAGE_SIZE_IN_SECTORS		(PAGE_SIZE/IDE_SECTOR_SIZE)

/*Maximum number of SGL entries.*/

#define	MAX_SGL_ENTRIES_PER_SRB	\
    (((MAX_SECTORS_PER_IDE_TRANSFER * MAX_STRIPES_PER_ROW) / \
    (min(MIN_STRIPE_SIZE_IN_SECTORS, PAGE_SIZE_IN_SECTORS)))+1)
/*#define MAX_SGL_ENTRIES_PER_SRB	\
    (((MAX_SECTORS_PER_IDE_TRANSFER * MAX_STRIPES_PER_ROW) / \
    (min(MIN_STRIPE_SIZE_IN_SECTORS, PAGE_SIZE_IN_SECTORS))) + 1)
*/
/*Maximum number of SGL entries.*/
#define	MAX_SGL_ENTRIES_PER_PHYSICAL_DRIVE ( \
    (((MAX_SECTORS_PER_IDE_TRANSFER) /	\
    (PAGE_SIZE_IN_SECTORS)) + 1 \
    + 1 	/* used for alignment adjustments */ \
    ) * 2  /* guarantees we have enough entries in 4KB region */ \
    )


/* SGL physical boundary.*/

#define	SGL_HW_BOUNDARY			(4*1024)


/* Memory region boundary.*/

#define	REGION_HW_BOUNDARY		(64*1024)

/* Maximum number of sectors accepted by IDE devices in a transfer.*/

#define	MAX_SECTORS_PER_IDE_TRANSFER	256


/* Maximum transfer length for IDE devices.*/

#define	MAX_BYTES_PER_IDE_TRANSFER \
    (MAX_SECTORS_PER_IDE_TRANSFER * IDE_SECTOR_SIZE)

/*
* the whole value is multiplied by two since there is a
* possibility that we get more than 128K transfer for
* one Drive per One SRB
*/
#define	MAX_BUF_CHUNKS \
    (( MAX_SECTORS_PER_IDE_TRANSFER  * MAX_STRIPES_PER_ROW)/ \
    MIN_STRIPE_SIZE_IN_SECTORS )


/*
* Maximum transfer length in sectors per SRB.
* TO DO: transform into a variable.
*/
#define	MAX_SECTORS_PER_SRB \
    (MAX_SECTORS_PER_IDE_TRANSFER * MAX_STRIPES_PER_ROW)

/*
* Maximum number of PDDs that can be derived from an SRB.
* (For logical drives, SRBs are split into one or more PDDs per
* physical drive in the set).
* This number is used to request the allocation of the proper
* SRB extension size.
*/

#define	MAX_PDDS_PER_SRB		MAX_STRIPES_PER_ROW

#define	MAX_PHYSICAL_REQUEST_BLOCKS \
    (MAX_SECTORS_PER_SRB / MAX_SECTORS_PER_IDE_TRANSFER)

/*
* End-of-List marker. Used for array index fields.
*/

#define	EOL				-1

#define	DRIVE_OFFLINE			0x80	/* all status except online and critical*/

#define	END_OF_LIST_FLAG		0x80000000


#define	PRIAMRY_CHANNEL_INTERRUPT	0x04
#define	SECONDARY_CHANNEL_INTERRUPT	0x08


/*
*-------------------------------------------------------------------
* Macros Definition
*-------------------------------------------------------------------
*/
/*Queue States */
#define	DEVICE_QUEUE_1_FROZEN		0x01
#define	DEVICE_QUEUE_2_FROZEN		0x02
#define	DEVICE_QUEUE_3_FROZEN		0x04
#define	DEVICE_QUEUE_4_FROZEN		0x08
#define	ADAPTER_QUEUE_FROZEN		0x10
#define	UNFROZEN			0x00
#define	NOT_FROZEN			0x00
#define	FROZEN				0x04
#define	FROZENAFTERHACB			0x02
/*Queue State Flags */
#define	FREEZE				0x00
#define	FREEZE_DUE_TO_ERROR		0x00
#define	SET_ACCORDING_TO_CONTROLFLAGS	0x01
#define	UNFREEZE			0x02

/*Flag Definitions*/
#define	QUEUE_AT_TAIL			0
#define	QUEUE_AT_FRONT			1

#define	SRB_STATUS_SUCCESS		0
#define	SRB_STATUS_PENDING		1
#define	SRB_STATUS_ERROR		2

/***************************************************************************
* From Linux
***************************************************************************/
#define	MIDE_STATUS_OK			0x00    /* NO error */
#define	MIDE_STATUS_BUS_BUSY		0x01    /* BUS stayed busy through time out period */
#define	MIDE_STATUS_BAD_TARGET		0x02	/* BAD target. */
#define	MIDE_STATUS_ABORT		0x03    /* Told to abort for some other reason     */
#define	MIDE_STATUS_ERROR		0x04    /* Internal error                          */
#define	MIDE_STATUS_RESET		0x05    /* Reset by somebody.                      */

#define	DRIVER_OK			0x00    /* Driver status                           */

#define	READ				0
#define	WRITE 				1

#define	TEST_UNIT_READY			0x00
#define	REZERO_UNIT			0x01
#define	REQUEST_SENSE			0x03
#define	FORMAT_UNIT			0x04
#define	READ_BLOCK_LIMITS		0x05
#define	REASSIGN_BLOCKS			0x07
#define	READ_6				0x08
#define	WRITE_6				0x0a
#define	SEEK_6				0x0b
#define	READ_REVERSE			0x0f
#define	WRITE_FILEMARKS			0x10
#define	SPACE				0x11
#define	INQUIRY				0x12
#define	RECOVER_BUFFERED_DATA		0x14
#define	MODE_SELECT			0x15
#define	RESERVE				0x16
#define	RELEASE				0x17
#define	COPY				0x18
#define	ERASE				0x19
#define	MODE_SENSE			0x1a
#define	START_STOP			0x1b
#define	RECEIVE_DIAGNOSTIC		0x1c
#define	SEND_DIAGNOSTIC			0x1d
#define	ALLOW_MEDIUM_REMOVAL		0x1e
#define	SET_WINDOW			0x24
#define	READ_CAPACITY			0x25
#define	READ_10				0x28
#define	WRITE_10			0x2a
#define	SEEK_10				0x2b
#define	WRITE_VERIFY			0x2e
#define	VERIFY				0x2f
#define	SEARCH_HIGH			0x30
#define	SEARCH_EQUAL			0x31
#define	SEARCH_LOW			0x32
#define	SET_LIMITS			0x33
#define	PRE_FETCH			0x34
#define	READ_POSITION			0x34
#define	SYNCHRONIZE_CACHE		0x35
#define	LOCK_UNLOCK_CACHE		0x36
#define	READ_DEFECT_DATA		0x37
#define	MEDIUM_SCAN			0x38
#define	COMPARE				0x39
#define	COPY_VERIFY			0x3a
#define	WRITE_BUFFER			0x3b
#define	READ_BUFFER			0x3c
#define	UPDATE_BLOCK			0x3d
#define	READ_LONG			0x3e
#define	WRITE_LONG			0x3f
#define	CHANGE_DEFINITION		0x40
#define	WRITE_SAME			0x41
#define	READ_TOC			0x43
#define	LOG_SELECT			0x4c
#define	LOG_SENSE			0x4d
#define	MODE_SELECT_10			0x55
#define	RESERVE_10			0x56
#define	RELEASE_10			0x57
#define	PERSISTENT_RESERVE_IN		0x5e
#define	PERSISTENT_RESERVE_OUT		0x5f
#define	MOVE_MEDIUM			0xa5
#define	READ_12				0xa8
#define	WRITE_12			0xaa
#define	WRITE_VERIFY_12			0xae
#define	SEARCH_HIGH_12			0xb0
#define	SEARCH_EQUAL_12			0xb1
#define	SEARCH_LOW_12			0xb2
#define	READ_ELEMENT_STATUS		0xb8
#define	SEND_VOLUME_TAG			0xb6
#define	WRITE_LONG_2			0xea


/*
*  Status codes
*/

#define	GOOD				0x00
#define	CHECK_CONDITION			0x01
#define	CONDITION_GOOD			0x02
#define	BUSY				0x04
#define	INTERMEDIATE_GOOD		0x08
#define	INTERMEDIATE_C_GOOD		0x0a
#define	RESERVATION_CONFLICT		0x0c
#define	COMMAND_TERMINATED		0x11
#define	QUEUE_FULL			0x14
#define	STATUS_MASK			0x3e

/*
*  SENSE KEYS
*/

#define	NO_SENSE			0x00
#define	RECOVERED_ERROR			0x01
#define	NOT_READY			0x02
#define	MEDIUM_ERROR			0x03
#define	HARDWARE_ERROR			0x04
#define	ILLEGAL_REQUEST			0x05
#define	UNIT_ATTENTION			0x06
#define	DATA_PROTECT			0x07
#define	BLANK_CHECK			0x08
#define	COPY_ABORTED			0x0a
#define	ABORTED_COMMAND			0x0b
#define	VOLUME_OVERFLOW			0x0d
#define	MISCOMPARE			0x0e

/* from <linux/fs.h> */



/* from <linux/hdreg.h> */
#define	MARK_ERR			0x01    /* Bad address mark */
#define	TRK0_ERR			0x02    /* couldn't find track 0 */
#define	ABRT_ERR			0x04    /* Command aborted */
#define	MCR_ERR				0x08    /* media change request */
#define	ID_ERR				0x10    /* ID field not found */
#define	MC_ERR				0x20    /* media changed */
#define	ECC_ERR				0x40    /* Uncorrectable ECC error */
#define	BBD_ERR				0x80    /* pre-EIDE meaning:  block marked bad */
#define	ICRC_ERR			0x80    /* new meaning:  CRC error during transfer */

/****************************************************************************
* copy linux Defines over
******************************/

#define MIDE_TIMEOUT_VALUE		2*15

/*
*-------------------------------------------------------------------
* Structure Definition
*-------------------------------------------------------------------
*/

/*
Inquiry buffer structure. This is the data returned from the target
after it receives an inquiry.

This structure may be extended by the number of bytes specified
in the field AdditionalLength. The defined size constant only
includes fields through ProductRevisionLevel.

The NT SCSI drivers are only interested in the first 36 bytes of data.
*/

#define INQUIRYDATABUFFERSIZE		36

typedef struct _INQUIRYDATA {
    UCHAR	DeviceType : 5;
    UCHAR	DeviceTypeQualifier : 3;
    UCHAR	DeviceTypeModifier : 7;
    UCHAR	RemovableMedia : 1;
    UCHAR	Versions;
    UCHAR	ResponseDataFormat;
    UCHAR	AdditionalLength;
    UCHAR	Reserved[2];
    UCHAR	SoftReset : 1;
    UCHAR	CommandQueue : 1;
    UCHAR	Reserved2 : 1;
    UCHAR	LinkedCommands : 1;
    UCHAR	Synchronous : 1;
    UCHAR	Wide16Bit : 1;
    UCHAR	Wide32Bit : 1;
    UCHAR	RelativeAddressing : 1;
    UCHAR	VendorId[8];
    UCHAR	ProductId[16];
    UCHAR	ProductRevisionLevel[4];
    UCHAR	VendorSpecific[20];
    UCHAR	Reserved3[40];
} INQUIRYDATA, *PINQUIRYDATA;

/*
* Read Capacity Data - returned in Big Endian format
*/



typedef struct _READ_CAPACITY_DATA {
    ULONG	LogicalBlockAddress;
    ULONG	BytesPerBlock;
} READ_CAPACITY_DATA, *PREAD_CAPACITY_DATA;

/*
Inquiry defines. Used to interpret data returned from target as result
of inquiry command.

DeviceType field
*/

#define	DIRECT_ACCESS_DEVICE		0x00    /* disks */
#define	SEQUENTIAL_ACCESS_DEVICE	0x01    /* tapes */
#define	PRINTER_DEVICE			0x02    /* printers */
#define	PROCESSOR_DEVICE		0x03    /* scanners, printers, etc */
#define	WRITE_ONCE_READ_MULTIPLE_DEVICE	0x04    /* worms */
#define	READ_ONLY_DIRECT_ACCESS_DEVICE	0x05    /* cdroms */
#define	SCANNER_DEVICE			0x06    /* scanners */
#define	OPTICAL_DEVICE			0x07    /* optical disks */
#define	MEDIUM_CHANGER			0x08    /* jukebox */
#define	COMMUNICATION_DEVICE		0x09    /* network */
#define	LOGICAL_UNIT_NOT_PRESENT_DEVICE	0x7F
#define	DEVICE_QUALIFIER_NOT_SUPPORTED	0x03

/*
 * SStatus in Values in 3112 for Detecting the Phy
 * DET status
 */
#define DET_NO_DEVICE                0x00
/* Device Detected but PHY Comm. Not established */
#define DET_DEVICE_DETECTED_PHY_BAD  0x01
/* Device Detected and PHY COMM extablished. */
#define DET_DEVICE_DETECTED_PHY_GOOD 0x03
/* PHY in offline mode. */
#define DET_PHY_OFFLINE      0x04

/*
DeviceTypeQualifier field
*/

#define	DEVICE_CONNECTED		0x00
#define DIR_IN 1
#define DIR_OUT 2
#define NORMAL 0
#define SUSPEND 1

#endif /*__MEGAIDE_ADAPTER_H__*/

/*vi set ts=8:*/
