/*
 * Copyright (c) 2001,2002 Eric Moore
 * Copyright (c) 2001,2002 Vanishree Sabapathi
 * Copyright (c) 2002 LSI Logic Corporation
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The party using or redistributing the source code and binary forms
 *    agrees to the disclaimer below and the terms and conditions set forth
 *    herein.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 *	$FreeBSD: src/sys/contrib/dev/mide/inc/mide_char.h,v emoore Exp$
 */

#ifndef __MEGAIDE_CHAR_H__
#define __MEGAIDE_CHAR_H__

/* Function Prototypes */

static d_open_t mide_open;
static d_close_t mide_close;
/*d_read_t mide_read;*/
/*d_write_t mide_write;*/
static d_ioctl_t mide_ioctl;

#define MIDE_MAJOR 171

static struct cdevsw mide_cdevsw = {
	mide_open,
	mide_close,
/*	mide_read, */
	noread,
/*	mide_write, */
	nowrite,
	mide_ioctl,
	nopoll,
	nommap,
	nostrategy,
	"mide",
	MIDE_MAJOR,
	nodump,
	nopsize,
	0,
	-1
};

void megaidedev_attach(void);
void megaidedev_detach(void);
int HandleCharIOCTLCall(unsigned int cmd, caddr_t arg, u_long inlen, u_long outlen, int adp_no);
/*UCHAR abort_passthu_command(PHW_DEVICE_EXTENSION DeviceExtension, Scsi_Cmnd *pstScsiCmd);*/
/*static void megaidedev_ioctl_over(Scsi_Cmnd * pstScsiCmd);*/
long array_to_int(const char * pcArray);
UCHAR abort_passthu_command(PHW_DEVICE_EXTENSION DeviceExtension, void *pstScsiCmd);


#endif /* __MEGAIDE_CHAR_H__ */
