/*
 * Copyright (c) 2001,2002 Eric Moore
 * Copyright (c) 2001,2002 Vanishree Sabapathi
 * Copyright (c) 2002 LSI Logic Corporation
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The party using or redistributing the source code and binary forms
 *    agrees to the disclaimer below and the terms and conditions set forth
 *    herein.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 *	$FreeBSD: src/sys/contrib/dev/mide/inc/mide_datatype.h,v emoore Exp$
 */

#ifndef __MEGAIDE_DATATYPE_H__
#define __MEGAIDE_DATATYPE_H__

/*
*-------------------------------------------------------------------
* Data Type Definitions
*-------------------------------------------------------------------
*/

/************************************************/
/*              definition of standard data types               */
/************************************************/
#define CHAR	char
#define UCHAR	unsigned char
#define BYTE	unsigned char
#define SHORT	short
#define USHORT	unsigned short
#define BOOLEAN	long
#define LONG	long
#define ULONG	unsigned long
#define VOID	void
#define UINT	unsigned int
#define UWORD	unsigned short /*Nagendra 02/06/02*/


typedef CHAR	*PCHAR;
typedef UCHAR	*PUCHAR;
typedef BYTE	*PBYTE;
typedef SHORT	*PSHORT;
typedef USHORT	*PUSHORT;
typedef BOOLEAN	*PBOOLEAN;
typedef LONG	*PLONG;
typedef ULONG	*PULONG;
typedef VOID	*PVOID;
typedef UINT	*PUINT;
typedef UWORD	*PUWORD; /*Nagendra 02/06/02*/


#ifndef TRUE
#define TRUE		1
#endif

#ifndef FALSE
#define FALSE		0
#endif


/*
*-------------------------------------------------------------------
* Enumerated Data Type Definitions
*-------------------------------------------------------------------
*/

#endif /*__MEGAIDE_DATATYPE_H__*/
/*vi set ts=8:*/
