/*
 * Copyright (c) 2001,2002 Eric Moore
 * Copyright (c) 2001,2002 Vanishree Sabapathi
 * Copyright (c) 2002 LSI Logic Corporation
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The party using or redistributing the source code and binary forms
 *    agrees to the disclaimer below and the terms and conditions set forth
 *    herein.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 *	$FreeBSD: src/sys/contrib/dev/mide/inc/mide_kernel_lib.h,v emoore Exp$
 */

#ifndef __MEGAIDE_KERNEL_LIB_H__
#define __MEGAIDE_KERNEL_LIB_H__



extern void ScsiPortStallExecution(unsigned long usecs);
extern unsigned char ScsiPortReadPortUchar( void * resource, unsigned short port );
extern unsigned short ScsiPortReadPortUshort( void * resource, unsigned short port);
extern void ScsiPortWritePortUchar( void * resource, unsigned short port, unsigned char value);
extern void ScsiPortWritePortUlong( void * resource, unsigned short port, unsigned int value);
extern void ScsiPortWritePortBufferUshort( void * resource, unsigned short port, const void * addr, unsigned long count);
extern void ScsiPortReadPortBufferUshort( void * resource, unsigned short port, void * addr, unsigned long count );
extern unsigned char inb_Rlsi( unsigned short port );
extern void outb_Rlsi( unsigned short port, unsigned char value);
extern unsigned long ScsiPortReadPortUlong(void *resource, unsigned short port);
extern unsigned long ReadMemIoRegUlong(void *resource, unsigned long offset);
extern void WriteMemIoRegUlong(void *resource, unsigned long offset, unsigned long value);

extern __attribute__((regparm(0))) int printk_Rlsi(const char * fmt, ...) __attribute__ ((format (printf, 1, 2)));

extern int memcmp_Rlsi(const void * cs,const void * ct,size_t count);
extern void * memcpy_Rlsi(void * dest,const void *src,size_t count);
extern void * memmove_Rlsi(void * dest,const void *src,size_t count);
extern void * memset_Rlsi(void * s, int c, size_t count);
extern char * strncpy_Rlsi(char * dest,const char *src,size_t count);
extern int strncmp_Rlsi(const char * cs,const char * ct,size_t count);
extern char * strcpy_Rlsi(char * dest,const char *src);
extern int strcmp_Rlsi(const char *s1,const char *s2);

extern int pci_read_config_word_Rlsi(PHW_DEVICE_EXTENSION DeviceExtension, int where, unsigned short *val);
extern int pci_read_config_byte_Rlsi(PHW_DEVICE_EXTENSION DeviceExtension, int where, unsigned char *val);
extern int pci_write_config_word_Rlsi(PHW_DEVICE_EXTENSION DeviceExtension, int where, unsigned short val);
extern int pci_write_config_byte_Rlsi(PHW_DEVICE_EXTENSION DeviceExtension, int where, unsigned char val);

extern void spin_lock_Rlsi(PHW_DEVICE_EXTENSION DeviceExtension);
extern void spin_unlock_Rlsi(PHW_DEVICE_EXTENSION DeviceExtension);

extern void wake_up_Rlsi( PHW_DEVICE_EXTENSION DeviceExtension );
extern void sleep_on_timeout_Rlsi( PHW_DEVICE_EXTENSION DeviceExtension);

extern u_long CURRENT_TIME_RLSI(void);

#endif /* __MEGAIDE_KERNEL_LIB_H__ */
