/*
 * Copyright (c) 2001,2002 Eric Moore
 * Copyright (c) 2001,2002 Vanishree Sabapathi
 * Copyright (c) 2002 LSI Logic Corporation
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The party using or redistributing the source code and binary forms
 *    agrees to the disclaimer below and the terms and conditions set forth
 *    herein.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
  *	$FreeBSD: src/sys/contrib/dev/mide/inc/mide_pci.h,v emoore Exp$
*/

#ifndef __MEGAIDE_PCI_H__
#define __MEGAIDE_PCI_H__


/*#define DEFAULT_RATE	5*/
#define DEFAULT_RATE		1


/*sumanesh -- error injector datastructure place holder*/
#ifdef  ENABLE_ERROR_INJECTOR
#define DOUBLE_ERROR		0
#define WRITE_OTHER_ERROR	1
#define READ_ERROR_WRITE	2
#define MAX_STATE		6
#define MAX_PATTERN		10
#define CLEAR_ERROR		0x8000
#endif /* ENABLE_ERROR_INJECTOR*/

#ifdef BP_SUPPORT
ULONG bp_values[14] = { IOCTL_BPD_INIT_BACKPLANE,
			IOCTL_BPD_READ_REGISTER,
			IOCTL_BPD_WRITE_REGISTER,
			IOCTL_BPD_LED_CONTROL,
			IOCTL_BPD_BEEP_CONTROL,
			IOCTL_BPD_DOCK_STATUS,
			IOCTL_BPD_IDE_BUS_ISOLATION,
			IOCTL_BPD_GET_EVENT_LOG_INFO,
			IOCTL_BPD_CLEAR_EVENTS,
			IOCTL_BPD_ADD_EVENT,
			IOCTL_BPD_GET_EVENT,
			IOCTL_BPD_INITIALIZE,
			IOCTL_BPD_GET_ERROR_CODE,
			IOCTL_BPD_BEEP_STATUS };
#endif



/*
*-------------------------------------------------------------------
* Structure Definition
*-------------------------------------------------------------------
*/


typedef struct _KERN_PHYSICAL_DRIVE_INFO_
{
/*
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,0)
	dma_addr_t		dma_h_err_log_sec;
#endif
*/
}
KERN_PHYSICAL_DRIVE_INFO;



typedef struct _KERN_CHANNEL_
{
}
KERN_CHANNEL;


typedef struct _CARD_INFO
{
    PHW_DEVICE_EXTENSION	DeviceExtension;
    KERN_PHYSICAL_DRIVE_INFO	PhysicalDrive[MAX_DRIVES_PER_CONTROLLER];
/*	KERN_ARRAY_DRIVE_INFO	ArrayDrive[MAX_DRIVES_PER_CONTROLLER];*/
/*	KERN_LOGICAL_DRIVE_INFO	LogicalDrive[MAX_LOGICAL_DRIVES];*/
/*	KERN_CHANNEL	Channel[MAX_CHANNELS_PER_CONTROLLER]; */
    device_t		pstDev;
    dev_t		mide_dev;
    struct cam_sim 	*mide_sim;
    struct cam_path 	*mide_path;
    struct callout_handle mide_timeout;
    int			internal_wait;
#ifdef	SMPNG
    struct mtx 		midemtx;
#endif
}
CARD_INFO, *PCARD_INFO;


typedef void (*XPT_DONE)(union ccb *done_ccb);

typedef BOOLEAN (*FOUND_INTERRUPT_HANDLER)(PHW_DEVICE_EXTENSION DeviceExtension, PUCHAR pulChannel);
typedef BOOLEAN (*DISABLE_INTERRUPTS)(PHW_DEVICE_EXTENSION DeviceExtension);
typedef BOOLEAN (*ENABLE_INTERRUPTS)(PHW_DEVICE_EXTENSION DeviceExtension);
typedef BOOLEAN (*IS80PINCABLE)(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR ucChannelInd);
typedef BOOLEAN (*PROGRAMCONTROLLER)(PHW_DEVICE_EXTENSION  DeviceExtension, UCHAR ucTargetId, UCHAR ucMode);
typedef BOOLEAN (*ISPOSTCOMMANDTODRIVESUCCESS)(PHW_DEVICE_EXTENSION DeviceExtension, ULONG ulTargetId, ULONG ulStartBlock, ULONG ulBlockCount,UCHAR ucCmd, ULONG ulSglPhysicalAddress);


/* Note... we have to change this for each controller added*/
#define NUM_SUPPORTED_CONTROLLERS   ( RCC_SERVER_WORKS_CSB6 + 1)

typedef struct _CARD_SPECIFIC_FUNCTION
{
    FOUND_INTERRUPT_HANDLER	pfnFoundInterrupt;
    DISABLE_INTERRUPTS		pfnDisableInterrupts;
    ENABLE_INTERRUPTS		pfnEnableInterrupts;
    IS80PINCABLE		pfnIs80PinCable;
    PROGRAMCONTROLLER 		pfnProgramChip;
    ISPOSTCOMMANDTODRIVESUCCESS	pfnIsPostCommandToDriveSuccess;
}CARD_SPECIFIC_FUNCTION;

void ide_unregister(driver_t *driver, device_t pDEV );
void RemoveBuildInIDESupport( driver_t *driver, device_t parent );
int megaide_find_card( PHW_DEVICE_EXTENSION DeviceExtension , device_t dev );
int get_hyperdisk_option_rom_info(PHW_DEVICE_EXTENSION DeviceExtension);
void initialize_device_extension(PHW_DEVICE_EXTENSION DeviceExtension);
int scan_option_rom(unsigned char * pcRom, unsigned long ulRomSize, PHW_DEVICE_EXTENSION DeviceExtension);
LONG HyperDiskScanForDevices(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN InitIdeRaidController(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN FindDevices(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR Channel);
BOOLEAN GetIoMode(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR TargetId);
BOOLEAN GetTransferMode(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR TargetId);
BOOLEAN SetTransferMode(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR TargetId, MP_TRANSFER_MODE TransferMode);
BOOLEAN ProgramDriveFor64xChip(PHW_DEVICE_EXTENSION  DeviceExtension, UCHAR ucTargetId, UCHAR TransferMode);
BOOLEAN ProgramDriveFor68xChip(PHW_DEVICE_EXTENSION  DeviceExtension, UCHAR ucTargetId, UCHAR ucMode);
BOOLEAN ProgramDriveForCSB5Chip(PHW_DEVICE_EXTENSION  DeviceExtension, UCHAR ucTargetId, UCHAR ucMode);
BOOLEAN ClaimOurIOPorts(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN ReleaseOurIOPorts(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN DisableInterrupts(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN Disable64xInterrupts(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN Disable68xInterrupts(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN DisableCSB5Interrupts(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN DisableSata3112Interrupts(PHW_DEVICE_EXTENSION pDE);
BOOLEAN EnableInterrupts(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN Enable64xInterrupts(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN Enable68xInterrupts(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN EnableCSB5Interrupts(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN EnableSata3112Interrupts(PHW_DEVICE_EXTENSION pDE);
BOOLEAN IsDrivePresent(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR ucTargetId);
BOOLEAN IssueIdentify(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR DeviceNumber, UCHAR Channel, UCHAR Command);
BOOLEAN InitDriveFeatures(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN InitSingleDriveFeatures(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR ucDrvInd);
BOOLEAN set_multi_block_xfers(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR ucTargetId);
void SetDriveParameters(PHW_DEVICE_EXTENSION DeviceExtension);
void SetDriveParams(PHW_DEVICE_EXTENSION DeviceExtension,  UCHAR DeviceNumber);
VOID CleanUpAdapter(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN Is80PinCable(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR ucChannelId);
BOOLEAN Is64x80PinCable(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR ucChannelId);
BOOLEAN Is68x80PinCable(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR ucChannelId);
BOOLEAN IsCSB580PinCable(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR ucChannelId);
BOOLEAN FoundInterrupt(PHW_DEVICE_EXTENSION DeviceExtension, PUCHAR pulChannel);
BOOLEAN Found64xInterrupt(PHW_DEVICE_EXTENSION DeviceExtension, PUCHAR pulChannel);
BOOLEAN Found68xInterrupt(PHW_DEVICE_EXTENSION DeviceExtension, PUCHAR pulChannel);
BOOLEAN FoundCSB5Interrupt(PHW_DEVICE_EXTENSION DeviceExtension, PUCHAR pulChannel);
BOOLEAN PostCommandToDrive(PHW_DEVICE_EXTENSION DeviceExtension, ULONG ulTargetId, ULONG ulStartBlock, ULONG ulBlockCount, UCHAR ucCmd, ULONG ulSglPhysicalAddress);
BOOLEAN IsPostCommandToDriveSuccess(PHW_DEVICE_EXTENSION DeviceExtension, ULONG ulTargetId, ULONG ulStartBlock, ULONG ulBlockCount, UCHAR ucCmd, ULONG ulSglPhysicalAddress);
BOOLEAN IsPostCommandToDriveSuccess64x(PHW_DEVICE_EXTENSION DeviceExtension, ULONG ulTargetId, ULONG ulStartBlock, ULONG ulBlockCount, UCHAR ucCmd, ULONG ulSglPhysicalAddress);
BOOLEAN IsPostCommandToDriveSuccess68x(PHW_DEVICE_EXTENSION DeviceExtension, ULONG ulTargetId, ULONG ulStartBlock, ULONG ulBlockCount,UCHAR ucCmd, ULONG ulSglPhysicalAddress);
BOOLEAN IsPostCommandToDriveSuccessCSB5(PHW_DEVICE_EXTENSION DeviceExtension, ULONG ulTargetId,	ULONG ulStartBlock, ULONG ulBlockCount, UCHAR ucCmd, ULONG ulSglPhysicalAddress);
PHW_DEVICE_EXTENSION GetDeviceExtension(u_char ucIndex);
BOOLEAN alloc_mem_resource(PHW_DEVICE_EXTENSION pDE);

BOOLEAN AssignPtrsForDevExtension(PHW_DEVICE_EXTENSION DeviceExtension);
void FreePtrsForDevExtension(PHW_DEVICE_EXTENSION DeviceExtension);
BOOLEAN AssignSglPtrsForChannels(PHW_DEVICE_EXTENSION DeviceExtension);
void FreeSglPtrsForChannels(PHW_DEVICE_EXTENSION DeviceExtension);
static void mide_sglist_map_helper_channel(void *arg, bus_dma_segment_t *segs, int nseg, int error);
BOOLEAN AssignMemoryGatekeeper(PHW_DEVICE_EXTENSION DeviceExtension);
void FreeMemoryGatekeeper(PHW_DEVICE_EXTENSION DeviceExtension);

static void mide_periodic(void *data);
extern int CheckSubSysID(device_t dev);
#ifdef BP_SUPPORT
ULONG megaide_get_bp_opcode(ULONG opcode);
#endif

/* externs in the megaide_lib.o*/
#ifndef MIDE_COMPILE_CLOSED_SOURCE
extern void FlushCache(PHW_DEVICE_EXTENSION DeviceExtension);
extern size_t get_gatekeeper_size(void);
extern size_t get_scb_extension_size(void);
extern size_t get_physcial_drive_command_size(void);
extern void AtapiHwInitialize(PHW_DEVICE_EXTENSION DeviceExtension);
extern BOOLEAN GetConfigInfoAndErrorLogSectorInfo(PHW_DEVICE_EXTENSION DeviceExtension);
extern BOOLEAN ConfigureRaidDrives(PHW_DEVICE_EXTENSION DeviceExtension, PUCHAR pBuffer);
extern BOOLEAN EnquireProperties(PHW_DEVICE_EXTENSION DeviceExtension, BOOLEAN blBootTime);
extern void megaide_kill_backgroundtask_and_wait( PHW_DEVICE_EXTENSION  DeviceExtension );
extern void ClearPCIInterupt(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR ucChannel);
extern void check_for_config_update( PHW_DEVICE_EXTENSION DeviceExtension);
extern BOOLEAN megaide_atapi_startio( PHW_DEVICE_EXTENSION DeviceExtension,PFAST_IDE_SCB_EXTENSION scbExtension);
extern UCHAR HandleIOCTLCall(PHW_DEVICE_EXTENSION DeviceExtension, PFAST_IDE_SCB_EXTENSION ScbExtension );
extern void megaide_abort_ioctl(PHW_DEVICE_EXTENSION DeviceExtension, PFAST_IDE_SCB_EXTENSION ScbExtension );
extern BOOLEAN FastIDEResetBus(PHW_DEVICE_EXTENSION DeviceExtension);
extern void FastIDEInterrupt(PHW_DEVICE_EXTENSION DeviceExtension);
extern PLOGICAL_DRIVE_INFO GetLDInfo(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR  ChannelId, UCHAR TargetId, UCHAR Lun);
extern BOOLEAN SetMaxTransferMode(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR TargetId);
extern UCHAR GetInquiryTransferMode(PHW_DEVICE_EXTENSION DeviceExtension, UCHAR TargetId);
extern BOOLEAN FastIDEFireCommand(PHW_DEVICE_EXTENSION DeviceExtension);
extern UCHAR IsSataDriveConnected(PHW_DEVICE_EXTENSION pDE, UCHAR ucChannel);
/* SATA interface functions */
extern void mide_pm_init(PHW_DEVICE_EXTENSION pDE);
extern BOOLEAN sataDisableHPInterrupt(PHW_DEVICE_EXTENSION pDE);
extern BOOLEAN sataEnableHPInterrupt(PHW_DEVICE_EXTENSION pDE);
extern BOOLEAN sataDisablePMInterrupts(PHW_DEVICE_EXTENSION pDE);
extern BOOLEAN sataEnablePMInterrupts(PHW_DEVICE_EXTENSION pDE);
extern BOOLEAN Sata_Drv_Ready(PHW_DEVICE_EXTENSION DeviceExtension, ULONG Channel);
extern BOOLEAN mide_Suspend(PHW_DEVICE_EXTENSION pDE);
extern BOOLEAN mide_Resume(PHW_DEVICE_EXTENSION pDE);
extern BOOLEAN mide_ProcessPMChange(PHW_DEVICE_EXTENSION pDE);

#ifdef BP_SUPPORT
extern unsigned long idebp_discovery(  PHW_DEVICE_EXTENSION DeviceExtension );
extern void idebp_release(  PHW_DEVICE_EXTENSION DeviceExtension );
extern unsigned long idebp_check_dock_status(  PHW_DEVICE_EXTENSION DeviceExtension  );

#endif

#endif

#endif /*__MEGAIDE_INIT_H__*/
/*vi set ts=8:*/
