/*
 * Copyright (c) 2001,2002 Eric Moore
 * Copyright (c) 2001,2002 Vanishree Sabapathi
 * Copyright (c) 2002 LSI Logic Corporation
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The party using or redistributing the source code and binary forms
 *    agrees to the disclaimer below and the terms and conditions set forth
 *    herein.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 *	$FreeBSD: src/sys/contrib/dev/mide/inc/mide_scsi.h,v emoore Exp$
 */

#ifndef __MEGAIDE_SCSI_H__
#define __MEGAIDE_SCSI_H__

static void megaide_cam_action(struct cam_sim *sim, union ccb *ccb);
static void megaide_intr(void *);
void megaide_cam_detach(PHW_DEVICE_EXTENSION DeviceExtension);
int megaide_cam_attach(PHW_DEVICE_EXTENSION DeviceExtension);
static void megaide_cam_poll(struct cam_sim *sim);

static void megiade_cam_rescan_target(PHW_DEVICE_EXTENSION DeviceExtension,int target);
static void megiade_cam_rescan_callback(struct cam_periph *periph, union ccb *ccb);

void FastIDEProcessAndQueueRequest(PHW_DEVICE_EXTENSION DeviceExtension, struct ccb_scsiio *csio);
u_int32_t megiade_abort( PHW_DEVICE_EXTENSION DeviceExtension, struct ccb_abort *abort_ccb );
u_int32_t megiade_reset_bus( PHW_DEVICE_EXTENSION DeviceExtension, struct ccb_resetbus * resetbus_ccb);
u_int32_t megiade_reset_dev( PHW_DEVICE_EXTENSION DeviceExtension, struct ccb_resetdev * resetdev_ccb);


PFAST_IDE_SCB_EXTENSION scsi_malloc( PHW_DEVICE_EXTENSION DeviceExtension, VOID * pstScsiCmd,BOOLEAN AllocIoctl );
void scsi_free(PHW_DEVICE_EXTENSION DeviceExtension, VOID * pstScsiCmd );
void scsi_done(VOID * pstScsiCmd );

ULONG GetPhysicalAddressAndLength( void * request_buffer, unsigned short sglem , ULONG ulDataOffset, ULONG *pulContiguousLength );
void fill_sense_buffer( PFAST_IDE_SCB_EXTENSION ScbExtension , UCHAR error_byte, BOOLEAN blReadWriteError , ULONG error_sector );
void megaide_complete_command( PHW_DEVICE_EXTENSION DeviceExtension, PFAST_IDE_SCB_EXTENSION ScbExtension, int result );
void PassthruIOCTL_buffer_For_Map(PFAST_IDE_SCB_EXTENSION scbExtension, PUCHAR dataBuffer, ULONG dataSize, UCHAR Dir );
void Generic_Unmap_Request(PFAST_IDE_SCB_EXTENSION scbExtension);
static void megaide_map_request(PFAST_IDE_SCB_EXTENSION scbExtension);
static void megaide_unmap_request(PFAST_IDE_SCB_EXTENSION scbExtension);
static void megaide_request_map_helper(void *arg, bus_dma_segment_t *segs, int nseg, int error);

void presync_sglist(PCHANNEL pChannel);
void postsync_sglist(PCHANNEL pChannel);
void presync_gatekeeper(PHW_DEVICE_EXTENSION DeviceExtension,UCHAR command );
static void mide_gatekeeper_map_helper_channel(void *arg, bus_dma_segment_t *segs, int nseg, int error);
void postsync_gatekeeper(PHW_DEVICE_EXTENSION DeviceExtension,UCHAR command );
ULONG	Get_DataTransfer_Length(PFAST_IDE_SCB_EXTENSION scbExtension);

void
print_sglist(void * request_buffer,unsigned short sglem, int tag);


#endif /*__MEGAIDE_SCSI_H__*/
/*vi set ts=8:*/
